k_tan.c File Reference
`#include "math_libm.h"`
`#include "math_private.h"`
Include dependency graph for k_tan.c:

Go to the source code of this file.

## Functions

double attribute_hidden | __kernel_tan (double x, double y, int iy)

## Variables

static const double | one = 1.00000000000000000000e+00
static const double | pio4 = 7.85398163397448278999e-01
static const double | pio4lo = 3.06161699786838301793e-17
static const double | T []

## Function Documentation

## __kernel_tan()

double attribute_hidden __kernel_tan | ( | double | x,
|  | double | y,
|  | int | iy
| ) |  |

Definition at line 69 of file k_tan.c.

References fabs(), GET_HIGH_WORD, GET_LOW_WORD, one, pio4, pio4lo, SET_LOW_WORD, and T.

Referenced by tan().

{
double z,r,v,w,s;
int32_t ix,hx;
GET_HIGH_WORD(hx,x);
ix = hx&0x7fffffff; /* high word of |x| */
if(ix<0x3e300000) /* x < 2**-28 */
{if((int)x==0) { /* generate inexact */
u_int32_t low;
GET_LOW_WORD(low,x);
if(((ix|low)|(iy+1))==0) return one/fabs(x);
else return (iy==1)? x: -one/x;
}
}
if(ix>=0x3FE59428) { /* |x|>=0.6744 */
if(hx<0) {x = -x; y = -y;}
z = pio4-x;
w = pio4lo-y;
x = z+w; y = 0.0;
}
z = x*x;
w = z*z;
/* Break x^5*(T[1]+x^2*T[2]+...) into
* x^5(T[1]+x^4*T[3]+...+x^20*T[11]) +
* x^5(x^2*(T[2]+x^4*T[4]+...+x^22*[T12]))
*/
r = T[1]+w*(T[3]+w*(T[5]+w*(T[7]+w*(T[9]+w*T[11]))));
v = z*(T[2]+w*(T[4]+w*(T[6]+w*(T[8]+w*(T[10]+w*T[12])))));
s = z*x;
r = y + z*(s*(r+v)+y);
r += T[0]*s;
w = x+r;
if(ix>=0x3FE59428) {
v = (double)iy;
return (double)(1-((hx>>30)&2))*(v-2.0*(x-(w*w/(w+v)-r)));
}
if(iy==1) return w;
else { /* if allow error up to 2 ulp,
simply return -1.0/(x+r) here */
/* compute -1.0/(x+r) accurately */
double a,t;
z = w;
SET_LOW_WORD(z,0);
v = r-(z - x); /* z+v = r+x */
t = a = -1.0/w; /* a = -1.0/w */
SET_LOW_WORD(t,0);
s = 1.0+t*z;
return t+a*(s+t*v);
}
}
GET_HIGH_WORD
#define GET_HIGH_WORD(i, d)
Definition: math_private.h:108
r
GLdouble GLdouble GLdouble r
Definition: SDL_opengl.h:2079
z
GLdouble GLdouble z
Definition: SDL_opengl_glext.h:404
s
GLdouble s
Definition: SDL_opengl.h:2063
pio4lo
static const double pio4lo
Definition: k_tan.c:52
v
const GLdouble * v
Definition: SDL_opengl.h:2064
x
GLint GLint GLint GLint GLint x
Definition: SDL_opengl.h:1574
int32_t
signed int int32_t
Definition: SDL_config_windows.h:62
T
static const double T[]
Definition: k_tan.c:53
u_int32_t
unsigned int u_int32_t
Definition: math_private.h:31
SET_LOW_WORD
#define SET_LOW_WORD(d, v)
Definition: math_private.h:146
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
y
GLint GLint GLint GLint GLint GLint y
Definition: SDL_opengl.h:1574
GET_LOW_WORD
#define GET_LOW_WORD(i, d)
Definition: math_private.h:117
pio4
static const double pio4
Definition: k_tan.c:51
one
static const double one
Definition: k_tan.c:50
a
GLboolean GLboolean GLboolean GLboolean a
Definition: SDL_opengl_glext.h:1109
fabs
double fabs(double x)
Definition: s_fabs.c:22
t
GLdouble GLdouble t
Definition: SDL_opengl.h:2071

## Variable Documentation

## one

const double one = 1.00000000000000000000e+00

static

Definition at line 50 of file k_tan.c.

Referenced by __kernel_tan().

## pio4

const double pio4 = 7.85398163397448278999e-01

static

Definition at line 51 of file k_tan.c.

Referenced by __kernel_tan().

## pio4lo

const double pio4lo = 3.06161699786838301793e-17

static

Definition at line 52 of file k_tan.c.

Referenced by __kernel_tan().

## T

const double T[]

static

Initial value:
= {
3.33333333333334091986e-01,
1.33333333333201242699e-01,
5.39682539762260521377e-02,
2.18694882948595424599e-02,
8.86323982359930005737e-03,
3.59207910759131235356e-03,
1.45620945432529025516e-03,
5.88041240820264096874e-04,
2.46463134818469906812e-04,
7.81794442939557092300e-05,
7.14072491382608190305e-05,
-1.85586374855275456654e-05,
2.59073051863633712884e-05,
}

Definition at line 53 of file k_tan.c.

Referenced by __kernel_tan(), and runAdder().